# API Reference <a name="API Reference" id="api-reference"></a>

## Constructs <a name="Constructs" id="Constructs"></a>

### LambdaToEventbridge <a name="LambdaToEventbridge" id="@must-cdk/example.LambdaToEventbridge"></a>

#### Initializers <a name="Initializers" id="@must-cdk/example.LambdaToEventbridge.Initializer"></a>

```typescript
import { LambdaToEventbridge } from '@must-cdk/example'

new LambdaToEventbridge(scope: Construct, id: string, props: LambdaToEventbridgeProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@must-cdk/example.LambdaToEventbridge.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | - represents the scope for all the resources. |
| <code><a href="#@must-cdk/example.LambdaToEventbridge.Initializer.parameter.id">id</a></code> | <code>string</code> | - this is a a scope-unique id. |
| <code><a href="#@must-cdk/example.LambdaToEventbridge.Initializer.parameter.props">props</a></code> | <code><a href="#@must-cdk/example.LambdaToEventbridgeProps">LambdaToEventbridgeProps</a></code> | - user provided props for the construct. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@must-cdk/example.LambdaToEventbridge.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

represents the scope for all the resources.

---

##### `id`<sup>Required</sup> <a name="id" id="@must-cdk/example.LambdaToEventbridge.Initializer.parameter.id"></a>

- *Type:* string

this is a a scope-unique id.

---

##### `props`<sup>Required</sup> <a name="props" id="@must-cdk/example.LambdaToEventbridge.Initializer.parameter.props"></a>

- *Type:* <a href="#@must-cdk/example.LambdaToEventbridgeProps">LambdaToEventbridgeProps</a>

user provided props for the construct.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@must-cdk/example.LambdaToEventbridge.toString">toString</a></code> | Returns a string representation of this construct. |

---

##### `toString` <a name="toString" id="@must-cdk/example.LambdaToEventbridge.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@must-cdk/example.LambdaToEventbridge.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@must-cdk/example.LambdaToEventbridge.isConstruct"></a>

```typescript
import { LambdaToEventbridge } from '@must-cdk/example'

LambdaToEventbridge.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@must-cdk/example.LambdaToEventbridge.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@must-cdk/example.LambdaToEventbridge.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@must-cdk/example.LambdaToEventbridge.property.lambdaFunction">lambdaFunction</a></code> | <code>aws-cdk-lib.aws_lambda.Function</code> | *No description.* |
| <code><a href="#@must-cdk/example.LambdaToEventbridge.property.eventBus">eventBus</a></code> | <code>aws-cdk-lib.aws_events.IEventBus</code> | *No description.* |
| <code><a href="#@must-cdk/example.LambdaToEventbridge.property.vpc">vpc</a></code> | <code>aws-cdk-lib.aws_ec2.IVpc</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@must-cdk/example.LambdaToEventbridge.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `lambdaFunction`<sup>Required</sup> <a name="lambdaFunction" id="@must-cdk/example.LambdaToEventbridge.property.lambdaFunction"></a>

```typescript
public readonly lambdaFunction: Function;
```

- *Type:* aws-cdk-lib.aws_lambda.Function

---

##### `eventBus`<sup>Optional</sup> <a name="eventBus" id="@must-cdk/example.LambdaToEventbridge.property.eventBus"></a>

```typescript
public readonly eventBus: IEventBus;
```

- *Type:* aws-cdk-lib.aws_events.IEventBus

---

##### `vpc`<sup>Optional</sup> <a name="vpc" id="@must-cdk/example.LambdaToEventbridge.property.vpc"></a>

```typescript
public readonly vpc: IVpc;
```

- *Type:* aws-cdk-lib.aws_ec2.IVpc

---


## Structs <a name="Structs" id="Structs"></a>

### LambdaToEventbridgeProps <a name="LambdaToEventbridgeProps" id="@must-cdk/example.LambdaToEventbridgeProps"></a>

#### Initializer <a name="Initializer" id="@must-cdk/example.LambdaToEventbridgeProps.Initializer"></a>

```typescript
import { LambdaToEventbridgeProps } from '@must-cdk/example'

const lambdaToEventbridgeProps: LambdaToEventbridgeProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@must-cdk/example.LambdaToEventbridgeProps.property.deployVpc">deployVpc</a></code> | <code>boolean</code> | Whether to deploy a new VPC. |
| <code><a href="#@must-cdk/example.LambdaToEventbridgeProps.property.eventBusEnvironmentVariableName">eventBusEnvironmentVariableName</a></code> | <code>string</code> | Optional Name for the Lambda function environment variable set to the name of the Event bus. |
| <code><a href="#@must-cdk/example.LambdaToEventbridgeProps.property.eventBusProps">eventBusProps</a></code> | <code>aws-cdk-lib.aws_events.EventBusProps</code> | A new custom EventBus is created with provided props. |
| <code><a href="#@must-cdk/example.LambdaToEventbridgeProps.property.existingEventBusInterface">existingEventBusInterface</a></code> | <code>aws-cdk-lib.aws_events.IEventBus</code> | Existing instance of a custom EventBus. |
| <code><a href="#@must-cdk/example.LambdaToEventbridgeProps.property.existingLambdaObj">existingLambdaObj</a></code> | <code>aws-cdk-lib.aws_lambda.Function</code> | Existing instance of Lambda Function object, providing both this and `lambdaFunctionProps` will cause an error. |
| <code><a href="#@must-cdk/example.LambdaToEventbridgeProps.property.existingVpc">existingVpc</a></code> | <code>aws-cdk-lib.aws_ec2.IVpc</code> | An existing VPC for the construct to use (construct will NOT create a new VPC in this case). |
| <code><a href="#@must-cdk/example.LambdaToEventbridgeProps.property.lambdaFunctionProps">lambdaFunctionProps</a></code> | <code>aws-cdk-lib.aws_lambda.FunctionProps</code> | User provided props to override the default props for the Lambda function. |
| <code><a href="#@must-cdk/example.LambdaToEventbridgeProps.property.vpcProps">vpcProps</a></code> | <code>aws-cdk-lib.aws_ec2.VpcProps</code> | Properties to override default properties if deployVpc is true. |

---

##### `deployVpc`<sup>Optional</sup> <a name="deployVpc" id="@must-cdk/example.LambdaToEventbridgeProps.property.deployVpc"></a>

```typescript
public readonly deployVpc: boolean;
```

- *Type:* boolean
- *Default:* false

Whether to deploy a new VPC.

---

##### `eventBusEnvironmentVariableName`<sup>Optional</sup> <a name="eventBusEnvironmentVariableName" id="@must-cdk/example.LambdaToEventbridgeProps.property.eventBusEnvironmentVariableName"></a>

```typescript
public readonly eventBusEnvironmentVariableName: string;
```

- *Type:* string
- *Default:* EVENTBUS_NAME

Optional Name for the Lambda function environment variable set to the name of the Event bus.

---

##### `eventBusProps`<sup>Optional</sup> <a name="eventBusProps" id="@must-cdk/example.LambdaToEventbridgeProps.property.eventBusProps"></a>

```typescript
public readonly eventBusProps: EventBusProps;
```

- *Type:* aws-cdk-lib.aws_events.EventBusProps
- *Default:* None

A new custom EventBus is created with provided props.

---

##### `existingEventBusInterface`<sup>Optional</sup> <a name="existingEventBusInterface" id="@must-cdk/example.LambdaToEventbridgeProps.property.existingEventBusInterface"></a>

```typescript
public readonly existingEventBusInterface: IEventBus;
```

- *Type:* aws-cdk-lib.aws_events.IEventBus
- *Default:* None

Existing instance of a custom EventBus.

---

##### `existingLambdaObj`<sup>Optional</sup> <a name="existingLambdaObj" id="@must-cdk/example.LambdaToEventbridgeProps.property.existingLambdaObj"></a>

```typescript
public readonly existingLambdaObj: Function;
```

- *Type:* aws-cdk-lib.aws_lambda.Function
- *Default:* None

Existing instance of Lambda Function object, providing both this and `lambdaFunctionProps` will cause an error.

---

##### `existingVpc`<sup>Optional</sup> <a name="existingVpc" id="@must-cdk/example.LambdaToEventbridgeProps.property.existingVpc"></a>

```typescript
public readonly existingVpc: IVpc;
```

- *Type:* aws-cdk-lib.aws_ec2.IVpc

An existing VPC for the construct to use (construct will NOT create a new VPC in this case).

---

##### `lambdaFunctionProps`<sup>Optional</sup> <a name="lambdaFunctionProps" id="@must-cdk/example.LambdaToEventbridgeProps.property.lambdaFunctionProps"></a>

```typescript
public readonly lambdaFunctionProps: FunctionProps;
```

- *Type:* aws-cdk-lib.aws_lambda.FunctionProps
- *Default:* Default properties are used.

User provided props to override the default props for the Lambda function.

---

##### `vpcProps`<sup>Optional</sup> <a name="vpcProps" id="@must-cdk/example.LambdaToEventbridgeProps.property.vpcProps"></a>

```typescript
public readonly vpcProps: VpcProps;
```

- *Type:* aws-cdk-lib.aws_ec2.VpcProps

Properties to override default properties if deployVpc is true.

---



